.ifndef _stelnet_inc_
_stelnet_inc_=yes

USE_SSL=yes
USE_FWTK=yes
USE_SKEY=yes
USE_CRYPT=yes

LDADD += -L${LIBTELNET:H} ${TELNETLIB}

.include "../Makefile.inc"

INSTALL?=install.sh
.ifndef BSDOBJDIR
OBJMACHINE=yes
.endif
NOMAN=no
NOPIC=no
NOPROFILE=no
STRIP?=

SJGLIBS=
MISCLIB=
DMALLOCLIB=
DBUGLIB=
TELNETSRC?=${BASE}/stelnet

CFLAGS+= -I${TELNETSRC}/conf/${.OBJDIR:T} -I${TELNETSRC} -DAUTH_HPW -DAUTHENTICATION -DENCRYPTION 
CFLAGS+= -DPKE_ENCRYPTION 
# uncomment if you wan't sjg's original RSA on the fly key exchange...
CFLAGS+= -DPKE_GENRSA

# this makes us much more efficient
#CFLAGS+= -DLINEMODE -DKLUDGELINEMODE
LIBTELNET=${TELNETSRC}/lib/telnet/${.OBJDIR:T}/libtelnet.a
TELNETLIB?=-ltelnet
LDADD += ${CURSESLIB} ${TERMLIB}

BINDIR?=/usr/local/bin

.if defined(LIBFWTK) && exists(${LIBFWTK})
CFLAGS+= -Dauth_send=tn_auth_send -DUSE_FWTK
.endif

.ifndef _machine_inc_
_machine_inc_=yes
.if exists(${.CURDIR}/../Makefile.${MACHINE}.inc)
.include "${.CURDIR}/../Makefile.${MACHINE}.inc"
.elif exists(${.CURDIR}/../../Makefile.${MACHINE}.inc)
.include "${.CURDIR}/../../Makefile.${MACHINE}.inc"
.elif exists(${.CURDIR}/../../../Makefile.${MACHINE}.inc)
.include "${.CURDIR}/../../../Makefile.${MACHINE}.inc"
.elif exists(${.CURDIR}/../../../../Makefile.${MACHINE}.inc)
.include "${.CURDIR}/../../../../Makefile.${MACHINE}.inc"
.endif
.endif

CURSESLIB?= -lcurses
TERMLIB?= -ltermcap

.endif

