/*
 * Copyright (c) 1995 Simon J. Gerraty
 *
 * This acts as an interface to hashpw in libpke
 * See auth_hpw.c in libpke...
 */
/*-
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static char sccsid[] = "from: krb4encpwd.c	8.1 (Berkeley) 6/4/93";
static char rcsid[] = "$Id: authhpw.c,v 1.8 1996/01/07 10:09:14 sjg Exp $";
#endif /* not lint */


#ifdef	AUTH_OLDHPW
/*
 * COPYRIGHT (C) 1990 DIGITAL EQUIPMENT CORPORATION
 * ALL RIGHTS RESERVED
 *
 * "Digital Equipment Corporation authorizes the reproduction,
 * distribution and modification of this software subject to the following
 * restrictions:
 *
 * 1.  Any partial or whole copy of this software, or any modification
 * thereof, must include this copyright notice in its entirety.
 *
 * 2.  This software is supplied "as is" with no warranty of any kind,
 * expressed or implied, for any purpose, including any warranty of fitness
 * or merchantibility.  DIGITAL assumes no responsibility for the use or
 * reliability of this software, nor promises to provide any form of
 * support for it on any basis.
 *
 * 3.  Distribution of this software is authorized only if no profit or
 * remuneration of any kind is received in exchange for such distribution.
 *
 * 4.  This software produces public key authentication certificates
 * bearing an expiration date established by DIGITAL and RSA Data
 * Security, Inc.  It may cease to generate certificates after the expiration
 * date.  Any modification of this software that changes or defeats
 * the expiration date or its effect is unauthorized.
 *
 * 5.  Software that will renew or extend the expiration date of
 * authentication certificates produced by this software may be obtained
 * from RSA Data Security, Inc., 10 Twin Dolphin Drive, Redwood City, CA
 * 94065, (415)595-8782, or from DIGITAL"
 *
 */

#include <sys/types.h>
#include <arpa/telnet.h>
#include <pwd.h>
#include <stdio.h>

#ifdef	__STDC__
#include <stdlib.h>
#endif
#ifdef	NO_STRING_H
#include <strings.h>
#else
#include <string.h>
#endif

#include "encrypt.h"
#include "auth.h"
#include "misc.h"
#include "pkepub.h"

extern char *MyId, *Myname;
extern char *PkeErrstr;
int UseFWTK = 0;

extern auth_debug_mode;

static unsigned char str_data[1024] = { IAC, SB, TELOPT_AUTHENTICATION, 0,
			  		AUTHTYPE_OLDHPW, };
static unsigned char str_name[1024] = { IAC, SB, TELOPT_AUTHENTICATION,
					TELQUAL_NAME, };

#define	HPW_AUTH	0	/* Authentication data follows */
#define	HPW_REJECT	1	/* Rejected (reason might follow) */
#define HPW_ACCEPT	2	/* Accepted */
#define	HPW_CHALLENGE	3	/* Challenge for mutual auth. */
#define	HPW_ACK		4	/* Acknowledge */

/* telnet cannot use the version in libpke */

char *
pke_gets(prompt, buf, nbytes, echo)
	char *prompt, *buf;
	int nbytes, echo;
{
	return telnet_gets(prompt, buf, nbytes, echo);
}

static int
Data(ap, type, d, c)
	Authenticator *ap;
	int type;
	void *d;
	int c;
{
        unsigned char *p = str_data + 4;
	unsigned char *cd = (unsigned char *)d;

	if (c == -1)
		c = strlen((char *)cd);

        if (0) {
                printf("%s:%d: [%d] (%d)",
                        str_data[3] == TELQUAL_IS ? ">>>IS" : ">>>REPLY",
                        str_data[3],
                        type, c);
                printd(d, c);
                printf("\r\n");
        }
	*p++ = ap->type;
	*p++ = ap->way;
	*p++ = type;
        while (c-- > 0) {
                if ((*p++ = *cd++) == IAC)
                        *p++ = IAC;
        }
        *p++ = IAC;
        *p++ = SE;
	if (str_data[3] == TELQUAL_IS)
		printsub('>', &str_data[2], p - (&str_data[2]));
        return(net_write(str_data, p - str_data));
}

	int
authhpw_init(ap, server)
	Authenticator *ap;
	int server;
{
	pke_off();

	SetMyId(server);
	
	if (server) {
		str_data[3] = TELQUAL_REPLY;
	} else {
		str_data[3] = TELQUAL_IS;
	}
	return(1);
}

	int
authhpw_send(ap)
	Authenticator *ap;
{
	char *cp;
	
	if (!UserNameRequested) {
		if ((cp = getenv("USER")) == NULL)
			return 0;
		
		(void) printf("%s: no -l user specified, assuming %s\n",
			      MyId, cp);
		auth_encrypt_user(cp);
	}
	printf("%s: Trying AUTH_HPW '%s' ...\n", MyId, UserNameRequested);
	if (!auth_sendname(UserNameRequested, strlen(UserNameRequested))) {
		return(0);
	}

	if (!Data(ap, HPW_ACK, (void *)NULL, 0)) {
		return(0);
	}

	return(1);
}

		
/* server receives IS */
	void
authhpw_is(ap, data, cnt)
	Authenticator *ap;
	unsigned char *data;
	int cnt;
{
	static char buf[1024];
	char *cp;
	int (*verify)() = NULL;
	char *err = NULL;
	
	if (cnt-- < 1)
		return;

	switch (*data++) {
	case HPW_AUTH:
		bcopy((void *)data, (void *)buf, cnt);
		buf[cnt] = '\0';
#ifdef USE_FWTK
		if (UseFWTK)
			verify = fwtk_verify;
#endif
		if (hashpw_verify(UserNameRequested, verify, buf, &err) <= 0) {
			if (err == NULL)
				err = "Auth failed";
			Data(ap, HPW_REJECT, (void *)err, -1);
			auth_finished(ap, AUTH_REJECT);
			return;
		}
		Data(ap, HPW_ACCEPT, (void *)0, 0);
		auth_finished(ap, AUTH_USER);
		break;

	case HPW_CHALLENGE:
		break;


	case HPW_ACK:
		/* should have user name by now... */
		if (UserNameRequested) {
			int type = 0;
			char *challenge = NULL;

#ifdef USE_FWTK
			if (UseFWTK) {
				type = 1;
				alarm(0);
				challenge = fwtk_challenge(UserNameRequested, Myname);
			}
#endif
			cp = hashpw_challenge(UserNameRequested, type, challenge);
			if (cp == NULL) {
				/* don't clue them in, give them a fake */
				cp = "42*0*a9,7d,9f,9d,50,75,1a,*";
			}
			Data(ap, HPW_CHALLENGE, (void *)cp, strlen(cp));
		}
		break;
		
	default:
		Data(ap, HPW_REJECT, 0, 0);
		break;
	}
}


/* this what the client sees */
	void
authhpw_reply(ap, data, cnt)
	Authenticator *ap;
	unsigned char *data;
	int cnt;
{
	static char buf[1024];
	char *cp;
	
	if (cnt-- < 1)
		return;
	switch (*data++) {
	case HPW_REJECT:
		if (cnt > 0) {
			printf("%s: AUTH_HPW refuses authentication because %.*s\r\n",
				MyId, cnt, data);
		} else
			printf("%s: AUTH_HPW refuses authentication\r\n", MyId);
		auth_send_retry();
		return;
	case HPW_ACCEPT:
		printf("%s: AUTH_HPW accepts you\n", MyId);
		auth_finished(ap, AUTH_USER);
		return;
	case HPW_CHALLENGE:
		
		bcopy((void *)data, (void *)buf, cnt);
		buf[cnt] = '\0';

		if ((cp = hashpw_prompt(buf)) == NULL) {
			cp = "sorry about that";
		}
		Data(ap, HPW_AUTH, (void *)cp, strlen(cp));
		break;

	default:
		return;
	}
}

	int
authhpw_status(ap, name, level)
	Authenticator *ap;
	char *name;
	int level;
{
	int st;
	
	if (level < AUTH_USER)
		return(level);
	
	st = pke_status(NULL);
	if (UserNameRequested && (st & PKE_KEYSET)) {
		strcpy(name, UserNameRequested);
		return(AUTH_VALID);
	}
	return(AUTH_USER);
}

#define	BUMP(buf, len)		while (*(buf)) {++(buf), --(len);}
#define	ADDC(buf, len, c)	if ((len) > 0) {*(buf)++ = (c); --(len);}

	void
authhpw_printsub(data, cnt, buf, buflen)
	unsigned char *data, *buf;
	int cnt, buflen;
{
	char lbuf[32];
	register int i;

	buf[buflen-1] = '\0';		/* make sure its NULL terminated */
	buflen -= 1;

	switch(data[3]) {
	case HPW_REJECT:	/* Rejected (reason might follow) */
		strncpy((char *)buf, " REJECT ", buflen);
		goto common;

	case HPW_ACCEPT:	/* Accepted (name might follow) */
		strncpy((char *)buf, " ACCEPT ", buflen);
	common:
		BUMP(buf, buflen);
		if (cnt <= 4)
			break;
		ADDC(buf, buflen, '"');
		for (i = 4; i < cnt; i++)
			ADDC(buf, buflen, data[i]);
		ADDC(buf, buflen, '"');
		ADDC(buf, buflen, '\0');
		break;

	case HPW_AUTH:		/* Authentication data follows */
		strncpy((char *)buf, " AUTH", buflen);
		goto common2;

	case HPW_CHALLENGE:
		strncpy((char *)buf, " CHALLENGE", buflen);
		goto common2;

	case HPW_ACK:
		strncpy((char *)buf, " ACK", buflen);
		goto common2;

	default:
		sprintf(lbuf, " %d (unknown)", data[3]);
		strncpy((char *)buf, lbuf, buflen);
	common2:
		BUMP(buf, buflen);
		for (i = 4; i < cnt; i++) {
			sprintf(lbuf, " %d", data[i]);
			strncpy((char *)buf, lbuf, buflen);
			BUMP(buf, buflen);
		}
		break;
	}
}

#endif
