#ifndef DESENC_H
# define DESENC_H
#include <sys/types.h>

/* DE status bits */
#define DE_OK		1
#define DE_KEYSET	2
#define DE_CRYPTING	4

#define DE_DECRYPT	0
#define DE_ENCRYPT	1

#ifndef __P
#if __STDC__ || defined(__cplusplus)
#define __P(s) s
#else
#define __P(s) ()
#endif
#endif

/* desenc.c */
void 	de_setkeys	 __P((u_char *rkey, u_char *wkey));
#ifdef DES_KEY_SZ
u_char *	de_buf_ksched	 __P((des_key_schedule ksched, des_cblock *iv, u_char *in, u_char *out, int nbytes, int encrypt));
#endif
u_char *	de_buf_key	 __P((u_char *key, u_char *in, u_char *out, int nbytes, int encrypt));
u_char *	de_buf	 __P((u_char *buf, int nbytes, int encrypt));
int	de_encrypt	 __P((int, u_char *buf, int nbytes));
int	de_decrypt	 __P((int, u_char *buf, int nbytes));
int 	de_status	 __P((char **mp));
void 	de_setstatus	 __P((int s));
void 	de_on	 __P((int /*fd*/));
void 	de_off	 __P((int /*fd*/));

/* x2b.c */
char *  b2x      __P((char *buf, u_char *data, int nbytes));
int     x2b      __P((u_char *buf, char *data, int nbytes));

#endif
