/* NAME:
 *	missing.c - missing routines
 *
 * AUTHOR:
 *	Simon J. Gerraty <sjg@quick.com.au>
 */
/*
 *      @(#)Copyright (c) 1995, Simon J. Gerraty.
 *      
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */

#ifndef lint
static char RCSid[] = "$Id: missing.c,v 1.1 1997/03/02 23:16:33 sjg Exp $";
#endif

#include <sys/param.h>

#ifdef HAVE_CONFIG_H
# include "config.h"
#else
# if defined(__svr4__) || defined(BSD4_4)
#   define HAVE_STRCHR
# endif
# if (defined(sun) && !defined(__svr4__)) || defined(BSD)
#   define HAVE_BZERO
# endif
#endif

#include <string.h>

#if defined(HAVE_STRCHR) 
char *
index(s, c)
	const char *s;
	int c;
{
	return strchr(s, c);
}


char *
rindex(s, c)
	const char *s;
	int c;
{
	return strrchr(s, c);
}
#endif

#ifndef HAVE_BZERO
void
bzero(b, length)
	char *b;
	int length;
{
	(void) memset(b, 0, length);
}

int
bcmp(b1, b2, length)
	char *b1, *b2;
	int length;
{
	return memcmp(b1, b2, length);
}

void
bcopy(b1, b2, length)
	char *b1, *b2;
	int length;
{
#ifdef HAVE_MEMMOVE
	(void) memmove(b2, b1, length);
#else
	(void) memcpy(b2, b1, length);
#endif
}
#endif
