/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */
#ifdef PKE_GENRSA
#ifndef lint
static char RCSid[] = "$Id: pkeglue.c,v 1.2 1997/02/08 07:13:32 sjg Exp $";
#endif
#include <stdio.h>
#if defined(HAVE_STDLIB_H) || defined(__STDC__)
#include <stdlib.h>
#endif

#define _EXTERN
#include "pkelib.h"

FILE *PkeDumpLog = NULL;

/*
 * This is the simple way to ensure that our
 * keys get through telnet ok - as they may contain IAC, SE
 */
#if 4 * KEYBITS < 1024
static u_char buf[1024];
#else
static u_char buf[4 * KEYBITS];
#endif

u_char *
key2str(key, nbytes)
	u_char *key;
	int nbytes;
{
	register u_char *rcp = buf;
	int i, j;

	*rcp = '\0';
	for (i = j = 0; i < nbytes && j < sizeof (buf); i++, j += 3) {
		sprintf(&buf[j], "%02x,", key[i]);
	}
	return buf;
}

u_char *
str2key(key)
	u_char *key;
{
	register u_char *rcp = buf;
	int i, c;

	for (i = 0; i < sizeof (buf) - 4; i += 3) {
		if (sscanf(&key[i], "%02x,", &c) > 0)
			*rcp++ = c;
		else
			break;
	}
	*rcp++ = '\0';
	*rcp++ = '\0';
	*rcp++ = '\0';
	return buf;
}

#ifdef MAIN
int
main()
{
	static u_char key[256];
	u_char *p;
	int i;

	for (i = 0; i < 256; i++)
		key[i] = i;
	printf("key2str() -> %s\n", key2str(key, sizeof (key)));
	p = strdup(buf);
	
	hex_dump(key, sizeof (key));
	hex_dump(str2key(p), sizeof (key));
	exit(0);
}
#endif
#endif
