/*
 * RCSid:
 *	$Id: pkelib.h,v 1.2 1997/02/08 07:13:36 sjg Exp $
 */
/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */
#include <sys/types.h>
#include <sys/cdefs.h>

#include "des.h"

/* from my extern.h */
#undef EXTERN
#ifdef _EXTERN
# define EXTERN
#else
# define EXTERN extern
#endif

#define CLEAR(x)	memset((char *)x, 0, sizeof(x))

#ifndef KEYBITS
# define KEYBITS 512
#endif

#define ARRSTR(a, s) (strncpy(a, s, sizeof (a) - 1), (a)[sizeof(a) - 1] = '\0', (a))

/* PKE status bits */
#define PKE_OK		1
#define PKE_KEYSET	2
#define PKE_CRYPTING	4

/*
 * This is here to help ensure privgen and pubgen use same precision.
 */
EXTERN int keybits
#ifdef _EXTERN
	= KEYBITS
#endif
	;
EXTERN char *PkeErrstr;

__BEGIN_DECLS

/* pkelib.c */
void 	pke_init	 __P((void *key));
u_char *	pke_encrypt	 __P((u_char *buf, int nbytes));
u_char *	pke_decrypt	 __P((u_char *buf, int nbytes));
int	pke_status	__P((char **mp));
void	pke_on	__P((void));
void	pke_off	__P((void));
/* pkepriv.c */
u_char *	pke_privgen	 __P((u_char *pubkey, int k2));
/* pkepub.c */
u_char *	pke_pubgen	 __P((void));
int 	pke_privset	 __P((u_char *privkey, int k2));
/* pkeglue.c */
u_char *	key2str	 __P((u_char *key, int nbytes));
u_char *	str2key	 __P((u_char *key));
/* x2b.c */
char *  b2x      __P((char *buf, u_char *data, int nbytes));
int     x2b      __P((u_char *buf, char *data, int nbytes));

__END_DECLS
