/* grossly simplified now that we only use eay's libcrypto */
/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */
#ifdef PKE_GENRSA
#ifndef lint
static char RCSid[] = "$Id: pkepriv.c,v 1.3 1997/09/02 12:10:39 sjg Exp $";
#endif
#include <stdio.h>

#include "pkelib.h"
#ifdef USE_SSL
#include "rsa.h"
#include "x509.h"
#include "crypto.h"
#endif

u_char *
pke_privgen(pubkey, k2)
	u_char *pubkey;
	int k2;
{
	des_cblock key, key2;
	u_char keys[128];
	des_key_schedule ksched;
	static u_char privkey[1024];		/* be safe */
	u_char *pub;
	int slop, keysz, i = 0;

#ifdef USE_SSL
	RSA *rsa;
#endif /* USE_SSL */
	
	pub = str2key(pubkey);

#ifdef USE_SSL

	if ((rsa = RSA_new()) == NULL)
		goto err;
	if (!d2i_RSAPublicKey(&rsa, &pub, 1024))
		goto err;
#ifdef MAIN
	printf("\npke_privgen(%s), key:", pubkey);
#endif
#endif /* USE_SSL */
	
	des_check_key = 1;			/* avoid weak keys */
	keysz = sizeof (key);
	do {
		des_random_key(key);
		i = des_set_key(&key, ksched);
	} while (i < 0);
	memcpy(keys, key, sizeof (key));
	if (k2) {
		keysz *= 2;
		do {
			des_random_key(key2);
			i = des_set_key(&key2, ksched);
		} while (i < 0);
		memcpy(&keys[sizeof (key)], key2, sizeof (key));
	}
#ifdef MAIN
	hex_dump(keys, keysz);
#endif
	if (k2)
		de_setkeys(key2, key);		/* separate read/write keys */
	else
		pke_init(key);			/* initialize our engine */

#ifdef USE_SSL
	if ((i = RSA_public_encrypt(keysz, keys, privkey, rsa
#if SSLEAY_VERSION_NUMBER >= 0x0800
				    , RSA_PKCS1_PADDING
#endif
				    )) <= 0)

		goto err;
	RSA_free(rsa);
	rsa = NULL;
	
#ifdef MAIN
	printf("privkey:");
	hex_dump(privkey, i);
#endif
	return key2str(privkey, i);
#endif /* USE_SSL */

 err:
#ifdef USE_SSL
	if (rsa)
		RSA_free(rsa);
#endif
	return NULL;
}
#endif
