/*
 *      @(#)Copyright (c) 1995, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */

#ifndef lint
static char RCSid[] = "$Id: getpwbyname.c,v 1.2 1997/02/08 07:13:51 sjg Exp $";
#endif

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>

/*
 * <sjg> helper to hide various shadow passwd implementations
 */
#if defined(HAVE_SHADOW_H) || (defined(sun) && defined(__svr4__))
# include <shadow.h>
#endif

static char *
getshadow(p)
	struct passwd *p;
{
#if defined(HAVE_GETSPNAM) || (defined(sun) && defined(__svr4__))
	struct spwd *sp;

	if (sp = getspnam(p->pw_name))
		return sp->sp_pwdp;
#endif
	return NULL;
}

/*
 * <sjg> simple hook to let us hide details of shadow passwds
 */
struct passwd *
getpwbyname(name)
	const char *name;
{
	struct passwd *p;
	char *s;
	
	if (p = getpwnam(name)) {
		if (s = getshadow(p))
			p->pw_passwd = s;
	}
	return p;
}
