/*
 * RCSid:
 *	$Id: pkepub.h,v 1.13 1997/02/08 07:13:17 sjg Exp $
 */
/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */
#ifdef PKE_ENCRYPTION
#include <sys/types.h>
#include <sys/cdefs.h>

/* from my extern.h */
#undef EXTERN
#ifdef _EXTERN
# define EXTERN
#else
# define EXTERN extern
#endif

/* PKE status bits */
#define PKE_OK		1
#define PKE_KEYSET	2
#define PKE_CRYPTING	4

/*
 * command bytes for PKE_IS
 */
#define PKE_KEY	1
#define PKE_SR1 2
#define PKE_SR2 4
#define PKE_2KEY	8

__BEGIN_DECLS
/* pkepub.c */
u_char *	pke_encrypt	 __P((u_char *buf, int nbytes));
u_char *	pke_decrypt	 __P((u_char *buf, int nbytes));
int	pke_status	__P((char **mp));
void	pke_on	__P((void));
void	pke_off	__P((void));
/* privkey.c */
u_char *	pke_privgen	 __P((u_char *pubkey, int k2));
/* pubkey.c */
u_char *	pke_pubgen	 __P((void));
int 	pke_privset	 __P((u_char *privkey, int k2));

/* auth_hpw.c */
char *  hashpw_prompt    __P((char *msg));
int     hashpw_verify    __P((char *user, int (*verify)(), char *response, char **err));
char *  hashpw_challenge         __P((char *user, int type, char *challenge));

/* pkegets.c */
char *  pke_gets         __P((char *prompt, char *buf, int nbytes, int echo));

/* pkeauth.c */
char *  pke_challenge    __P((char *user, int *typep));
int     pke_verify       __P((char *user, char *response, char **err));
/* fwtkauth.c */
char *  fwtk_challenge   __P((char *user, char *prog));
int     fwtk_verify      __P((char *user, char *response, char **err));

/* x2b.c */
char *  b2x      __P((char *buf, u_char *data, int nbytes));
int     x2b      __P((u_char *buf, char *data, int nbytes));

__END_DECLS
#endif
