/* NAME:
 *	stpasswd - set user password in private database
 *
 * DESCRIPTION:
 *	This tool is used to update passwords in a private database.
 *	If the database being used is actually /etc/passwd, then we
 *	just invoke /usr/bin/passwd 
 *	
 * AUTHOR:
 *	Simon J. Gerraty <sjg@quick.com.au>
 */
/*
 *      @(#)Copyright (c) 1995, Simon J. Gerraty.
 *      
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */

#ifndef lint
static char RCSid[] = "$Id: stpasswd.c,v 1.5 1997/02/08 07:13:58 sjg Exp $";
#endif

#include <sys/param.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <unistd.h>
#include <time.h>

extern char *_path_authpasswd;

char *Myname, *progname;
extern char *__progname;
extern char *tempname;

int
main(argc, argv)
	int argc;
	char **argv;
{
	extern int optind, getopt();
#if !defined(__hpux__) && !defined(BSD4_4)
	extern char *optarg;
#endif
	extern char *getenv();
	char *user = getenv("USER");
	char buf[256];
	int i;

	if (Myname = strrchr(argv[0], '/'))
		Myname++;
	else
		Myname = argv[0];
	progname = Myname;
	__progname = Myname;
	
	while ((i = getopt(argc, argv, "f:")) != EOF) {
		switch (i) {
		case 'f':
			_path_authpasswd = optarg;
			break;
		}
	}
	if (optind < argc)
		user = argv[optind];

	/*
	 * handle OS specifics
	 */
	if (strcmp(_path_authpasswd, "/etc/passwd") == 0) {
		execl("/usr/bin/passwd", "passwd", user, NULL);
		perror("exec(/usr/bin/passwd)");
		exit(1);
	}
	
	if (local_passwd(user) == 0) {
		(void) sprintf(buf, "%s.old", _path_authpasswd);
		if (rename(_path_authpasswd, buf) == 0)
			exit(rename(tempname, _path_authpasswd) != 0);
	}
	exit(1);
}
